definition module CTExamples

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// A collection of examples.

import CTexture

modinterlace :: !(!.Int,!.Int,!.Int) !.Int !.Int -> Bool
simple_intl :: (!.Int -> .(!.Int -> Bool))
lims :: a -> .(a->a) | *,+,-,<,half,one,zero a
weave :: [!RVec2-> a Real] !.Real .[!RVec2-> a Real] !.Real (!RVec2-> a Real) 
         (!Int -> .(!Int -> .Bool)) !.Real -> (!RVec2-> a Real) | *> a

tartan_intl :: (!.Int -> .(!.Int -> Bool))
mksett :: !.Bool ![(a,.Int)] -> .[.b -> a]


quarter :: (Vec2 !Real) -> RealCol Real
truchet :: !(Vec2 !.Real) -> RealCol Real

dither :: .Real !.((Vec2 !Real) -> .Real) (Vec2 .Real) -> RealCol Real
makegreybmap :: !(.Int,.Int,{#.Char}) -> .(.(Vec2 !Real) -> Real)

(|+|) infixl 6  :: !a !a -> a | *,+,- a
bombing :: !.Real (!(.Vec2 !Real) -> a) -> .(!(Vec2 !.Real) -> a) | *,+,- a

warp :: !.Real !.(Vec2 !Real) -> .(!(Vec2 !.Real) -> Vec2 Real)
warpfold :: (!a->v:(!a->a)) !.[a] u:(!a-> .b)->u:(!a -> .b) | +,-,zero a, [u<=v]

// ***

sphermap :: !.(.RVec2 -> .a) !RVec3 -> .a
spherlift :: !.(.RVec2 -> .a) !RVec3 .b .c -> .a
mkbplanet :: !{#.Char} !{#.Char} .RVec3 !.Real *a -> *(w:(!(Vec3 .Real) 
   -> v:(!(Vec3 .Real) -> u:(.b -> RealCol Real))),*a) 
   | FileSystem a, [u<=v,v<=w]

// Escher reptiles
txmotifp3 :: (!RVec2-> RColour) !RColour -> .(!.RVec2-> RColour)

kaleidoscope :: v:(!RVec2 -> .a) -> u:(!.RVec2 -> .a), [u<=v]

parquet :: !.Real !.Real v:(!RVec2 -> .a) -> u:(!(Vec2 .Real) -> .a),[u<=v]



