definition module CTUtils

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************

import StdEnv, StdPicture, CTView

:: NTree a = NVoid | NNd a (NTree a) (NTree a)
treesort :: ![!a] -> ![!a] | < a
quicksort :: ![!a] -> ![!a] | < a

normallist :: a a .[a] -> .[a] | *,+,-,/,< a
ufold :: (!a -> .(*b -> *b)) *b ![!a] -> *b
plotline :: .Viewport [.Vec2 Real] -> .(*Picture -> .Picture)
plotfun :: .Viewport .Int .Int (RealCol .Real) (Real -> .Real) *Picture -> .Picture
plotfuns :: .Viewport ![(.Int,.Int,RealCol .Real,Real -> .Real)] *Picture -> .Picture

