module example0

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 09.01
// *****************************************************
// Your first example. Just something to start with.

import CTexture
// Window size
whsize =: 300 // 700   // If you wish to wait a bit longer...
wsize =: whsize
hsize =: whsize
// Viewport params
commxy=:1.0
xmin =: ~commxy
xmax =:  commxy
ymin =: ~commxy
ymax =:  commxy

// Open standard texture viewport
tecport =: mkvport wsize hsize xmin ymin xmax ymax

// Attach it to the IO window. The principal horse: mainfun
//  is defined below
Texture =: texturwin "DIBtextures" tecport mainfun

// This is the main trigger
Start :: *World -> *World
Start world = Texture world

// periodic functions; it is (obviously) a tesselation. Test both!
xfun1 (V2 x y) = sin(x+sin(y+sin x)) - sin(y+sin(x+sin y))
xfun2 (V2 x y) = floor(sin(x+sin(y+sin x))) - 
                 floor(sin(y+sin(x+sin y)))

mainfun = interpol RGold RBlue Linear o sscaled 0.1 xfun1
