definition module CTFunalg

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************

import StdBool, StdFunc, CTGeneral

instance + (a -> b) | + b
instance - (a -> b) | - b
instance * (a -> b) | * b
instance ~ (a -> b) | ~ b
instance / (a -> b) | / b
instance zero (a->b) | zero b
instance one (a->b) | one b
instance two (a->b) | two b
instance three (a->b) | three b
instance half (a->b) | half b
instance abs (a->b) | abs b
instance fromReal (a->b) | fromReal b
instance fromInt (a->b) | fromInt b
(*-) infixr 7 :: !b (a->b) -> (a->b) | * b
(*->) infixr 7 :: w:(a -> b) v:(a -> c b) -> u:(a -> c b) | *> c & * b,[u<=v,u<=w]
minf :: w:(a -> b) v:(a -> b) -> u:(a -> b) | < b, [u<=v,u<=w]
maxf :: w:(a -> b) v:(a -> b) -> u:(a -> b) | < b, [u<=v,u<=w]
posit :: v:(.a -> b) -> u:(.a -> b) | <,zero b,[u<=v]

translated :: !a .(!a -> .b) !a -> .b | - a
scaled :: !a v:(a->.b) -> u:(a->.b) | /a,[u <=v]
transf :: w:(.a->.b) v:(.b->.c) -> u:(.a->.c), [u<=v,u<=w]
displace :: .(!a->a) .(!a->.b) !a -> .b | + a

clamp :: !a !a !a -> a | < a
ramp :: .(!a -> a) | < , one , zero a
fmask :: x:(!a->b) w:(!a->.c) v:(!a->.c)->u:(!a->.c) | ==,zero b,[u<=v,u<=w,u<=x]
train :: .(!a->.b) !a -> .b | -,fromInt,toReal a

