definition module CTWindow

// *****************************************************
// Clean Texturing Library
// Copyright 2001 Jerzy Karczmarczuk, University of Caen
// Version 01.10
// *****************************************************
// Windows-specific interfacing issues. Build a rendering window,
//  show the bitmap, etc.

import StdEnv, CTView, StdWindow, StdBitmap, osbitmap, StdPStClass, StdMenuElement
import ostoolbox, StdProcess, pictCCall_12, StdPSt, StdControl, StdId, StdMenu
import Notice
import CTMapping

mkportwin :: .{#Char} .Viewport (.Picture -> *Picture) -> Window .NilLS .a *(PSt .b)
//mainwindow :: (a .Void *(PSt .Void)) *World -> .World | Windows a
mainwindow :: (Window NilLS .Void *(PSt .Void)) *World -> *World
drawDib :: !{#.Char} !.Int !.Int !*Picture -> .Picture
txwindow :: {#.Char} !Int !Int !Real !Real !Real !Real (!(Vec2 !Real)->RealCol .Real)->.(*World -> .World)
texturwin :: {#.Char} .Viewport ((Vec2 !Real) -> RealCol .Real) -> .(*World -> .World)

instance Show Void

notixt :: [.{#Char}] .{#Char} !*(.a,*PSt .b) -> *(.a,*PSt .b)
about :: .(*(.a,*PSt .b) -> *(.a,*PSt .b))
nope :: .(*(.a,*PSt .b) -> *(.a,*PSt .b))
getMstate :: .Id !*(.a,!*PSt .b) -> *(Bool,*(.a,*PSt .b))
getSqstate :: .Id !*(.a,*PSt .b) -> *(.Bool,*(.a,*PSt .b))
togglesq :: !.Id [.Id] !*(.a,!*PSt .b) -> *(.a,*PSt .b)


:: Txobj = {port::Viewport,bmap::{#Char}}
showBitmap :: !*(.a,!*PSt u:(.Int,w:[y:(.Id,u1:Txobj)])) -> *(.a,*PSt v:(Int,x:[z:(Id,u2:Txobj)])),[u1<=u2,y<=z,w<=x,u<=v]
savbitmap :: !*(.a,!*PSt (b,[(.Id,.Txobj)])) -> *(.a,*PSt (b,[(Id,Txobj)]))
findact :: a [(a,.Txobj)] -> {#Char} | == a
addwin :: .a .Viewport {#.Char} !*(PSt u:(.Int,w:[y:(.a,u1:Txobj)])) -> *PSt v:(Int,x:[z:(.a,u2:Txobj)]),[u1<=u2,y<=z,w<=x,u<=v] 
close :: !*(PSt (.Int,[(.Id,a)])) -> *PSt (Int,[(Id,a)])
removeact :: a u:[w:(a,.b)] -> (.Bool,v:[x:(a,.b)]) | == a, [w<=x,u<=v]

fchoices :: ![(.a,.b)] -> [(.a,.(.c -> .c))]
inpline :: .String .Id a .Id b -> LayoutControl (:+: .TextControl (:+: .EditControl .EditControl)) .c .d | toString a & toString b
inpline3 :: .String .Id a .Id b .Id c -> LayoutControl (:+: .TextControl (:+: .EditControl (:+: .EditControl .EditControl))) .d .e | toString a & toString b & toString c

quit :== closeProcess
togmark :: !.Bool .Id !*(PSt .a) -> *PSt .a
stbuts :: .(.a -> .(.b -> .(.c -> *(.d,*PSt .e) -> *(.d,*PSt .e)))) .a .b .c -> LayoutControl (:+: .ButtonControl .ButtonControl) .d *(PSt .e)
isT2 :: !.(Texture a) -> .Bool
isT3 :: !.(Texture a) -> .Bool

createdbwin :: .Viewport .{#Char} ((Vec2 !Real) -> RealCol !.Real) !*(.a,*PSt (.Int,[(.Id,.Txobj)])) -> *(.a,*PSt (Int,[(Id,Txobj)]))
makeport :: ![(.{#Char},.Texture Real)] .Id !.[Id] !*(.Id,*PSt (.Int,[(.Id,.Txobj)])) -> *(Id,*PSt (Int,[(Id,Txobj)]))
whichf :: ![(.a,.b)] .WState .Id -> (.a,.b)
v2dialog :: [(.String,.Texture Real)] .Id (.[a],.[b]) .[Id] *(.Id,*PSt (.Int,[(.Id,.Txobj)])) -> *(Id,*PSt (Int,[(Id,Txobj)])) | toString a & toString b

vget :: [(.a,.Maybe b)] (.c,.d) -> (.Viewscreen,(.c,.d)) | toInt , toReal b

txdialog :: .(*a -> *([(.String,.Texture Real)],*World)) *a -> .World | Ids a
initinterf :: [(.{#Char},.Texture Real)] .Id [.Id] [.Id] !*(PSt (.Int,[(.Id,.Txobj)])) -> *PSt (Int,[(Id,Txobj)])
v3dialog :: [(.String,.Texture Real)] a (.[b],.[c]) .[Id] *(.Id,*PSt (.Int,[(.Id,.Txobj)])) 
            -> *(Id,*PSt (Int,[(Id,Txobj)])) | toString b & toString c
m3port :: ![(.{#Char},.Texture Real)] .b !.[Id] !*(.Id,*PSt (.Int,[(.Id,.Txobj)])) 
          -> *(Id,*PSt (Int,[(Id,Txobj)]))


